#!/bin/sh
#set -x

# Print a short list of words with the same three random letters, whose
# checksum matches the checksum of today's date. The sum algorithm is
# the modulo-9 of this mapping:
#
#    a/j/s=1, b/k/t=2, c/l/u=3,
#    d/m/v=4, e/n/w=5, f/o/x=6,
#    g/p/y=7, h/q/z=8, i/r  =9
#
# No mystical mumbo-jumbo here! The simple challenge is for you to use
# these words in conversation today. It's a mind-livener.

Dicts=@INSTROOT@/dict/roots
# this is a directory of files of already checksummed words, where
# files suffixed by + have been sorted in order of increasing length.

alph=@INSTROOT@/dict/alphabet
cons=@INSTROOT@/dict/consonants
vowe=@INSTROOT@/dict/vowels

case $1 in 
    -*) R=`echo $1 | sed -e 's/-//'` 
	shift
	;;
    *)  
	R=`date +%Y%m%d | xargs @INSTROOT@/bin/root | awk '{ print $2 }'`
	;;
esac

if [ $# -lt 3 ] ; then 
	Lets=`@INSTROOT@/bin/randline $vowe $cons $cons | xargs echo`
	set -- $* $Lets
fi

a=$1
j=$2
s=$3
echo "$a $j $s"

[ -s $Dicts/$R+ ] && grep -hi "$a" $Dicts/$R+ | grep -i "$j" | grep -i "$s" | grep "...." \
    | fmt | head -5

