/*(c)Copyright 1995,2001 by Paul Shields, all rights reserved.
  Please read the file LICENSE distributed with this source code.*/

/* root.c - Examine the check sum of words, using a modulo-9 of the
   following mapping:

    a/j/s=1, b/k/t=2, c/l/u=3,
    d/m/v=4, e/n/w=5, f/o/x=6,
    g/p/y=7, h/q/z=8, i/r  =9
 */

int root(char *s)
{
  int i, n=0;
  for(i=0,n=0; s[i] != 0; i++)
    {
      if(s[i] >= 'A' && s[i] <= 'Z')
	  n += (s[i] - 'A' + 1);
	else
      if(s[i] >= 'a' && s[i] <= 'z')
	  n += (s[i] - 'a' + 1);
      if(s[i] >= '0' && s[i] <= '9')
	  n += (s[i] - '0');
      while(n > 9)
	n -= 9;
    }
  return n;
}


void calcroots(int numw, char *w[], int roots[])
{
  int i;
  for( i=0; i<numw; i++ ) {
     roots[i] = root( w[i] );
  }
}
