/*(c)Copyright 1995,2001 by Paul Shields, all rights reserved.
  Please read the file LICENSE distributed with this source code.*/

/* steganera.c - look at a list of words to find and match 
   words that have at least three letters in common.

   Output is three columns:
       1. the sum modulo 27, encoded into a letter
       2,3. the pair of words.
 */
#include <ctype.h>
#include <stdio.h>
#include <string.h>

#include "match.h"
#include "parse.h"
#include "sdecode.h"

main(int argc,char *argv[])
{
  int i,k,m,s;
  int numw,ilen,klen,ncom;
  char **words;
  char *p;

  /* scan text and parse into words */
  fparse( stdin, &numw, &words );
  
  /* match all pairs of words. print pairs with 
     more than 3 letters, who have at least 3 letters in common.*/

  for(i=0; i<numw; i++)
    for(k=i+1; k<numw; k++) {
      ilen=strlen( words[i] ); 
      klen=strlen( words[k] );
      ncom=numcommonletters( words[i], words[k]);

      /* skip short words. others must have 3 common letters but must not be identical. */
      if( ilen > 3 && klen > 3 && ncom >= 3) {
        if( ilen == ncom && klen == ncom ) {
	  // skip, unless the words are anagrams of one another
	  if( identical( words[i], words[k] ) )
	    continue;
	}
	printf("%c %s %s\n", sdecode( words[i], words[k] ), words[i], words[k]);
      }
    }

  exit(0);
}

