/* (c)copyright 2001 by Paul Shields, all rights reserved.
  Please read the file LICENSE distributed with this source code.*/

/* stegdeco.c - decode text that was encoded according to the rules
   in steganera.c. Words must be near each other in the text, though
   they needn't be adjacent, must have the same check sum, must
   be more than three letters long, and must have at least three
   letters in common. 
 */

#include <stdio.h>
 
#define bool int
#define false 0
#define true 1

#include "roots.h"
#include "match.h"
#include "parse.h"

void scanwords(int numw, char *w[])
{
  int i,j;
  static int roots[MAX_WORDS]; 
  static bool used[MAX_WORDS]; 
  char c;
  int ilen,jlen,ncom;

  calcroots(numw, w, roots); 

  for( i=0; i<numw; i++ )
    used[i]=false;

  for( i=0; i<numw; i++ ) {
    if( used[i] )
	continue;
    for( j=i+1; j<=i+5; j++ ) {
      if( used[j] )
	continue;

      if( roots[i]==roots[j] ) {

        ilen=strlen( w[i] ); 
        jlen=strlen( w[j] );
        ncom=numcommonletters( w[i], w[j]);

        /* skip short words. others must have 3 common letters but must not be identical. */
	if( ilen > 3 && jlen > 3 && ncom >=3) {
	  if( ilen == ncom && jlen == ncom ) {
	
          // skip, unless the words are anagrams of one another
          if( identical( w[i], w[j] ) )
            continue;
	  }

	  // check for hit
	  c = sdecode( w[i], w[j] );
	  printf("%c %d %s %s\n", c, roots[i], w[i], w[j] ); 

	  used[i]=true; used[j]=true; 
	  goto xx;
	}
      }
    }
   xx: 
  }
  printf("\n");
} 

main(int argc, char *argv[])
{
  int i,k,m,s;
  int numw;
  char **words;
  char *p;

  /* scan text and parse into words */
  fparse( stdin, &numw, &words );

  /* scan and output */
  scanwords( numw, words );
}

